//----------------------------------------------------------------------
//   Copyright 2010-2014 Fraunhofer IIS/EAS
//   Copyright 2014 NXP B.V.
//   Copyright 2014 Universit Pierre et Marie Curie
//   All Rights Reserved
//
//   Licensed under the Apache License, Version 2.0 (the
//   "License"); you may not use this file except in
//   compliance with the License.  You may obtain a copy of
//   the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in
//   writing, software distributed under the License is
//   distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
//   CONDITIONS OF ANY KIND, either express or implied.  See
//   the License for the specific language governing
//   permissions and limitations under the License.
//----------------------------------------------------------------------
//
//   Original Author: Karsten Einwich Fraunhofer IIS/EAS Dresden
//
//   Created on: 16.02.2010
//
//----------------------------------------------------------------------

#include <systemc-ams.h>
#include "sin_source_with_noise.h"

int sc_main(int argn, char* argc[])          // SystemC main program
{
  sca_tdf::sca_signal<double> sig_1;         // Signal to connect source w sink

  sin_source_with_noise src_1("src_1");      // Instantiate source
  src_1.out(sig_1);                          // Connect (bind) with signal

  // TODO 1.3: Create a tabular trace file named "tb_lab2a.dat"

  // TODO 1.3: and trace global signal sig_1

  // TODO 1.2: Perform a 10ms time domain simulation

  // TODO 1.3: and close tabular trace file

  // TODO 1.4: Create a tabular trace file named "tb_ac_lab2a"

  // TODO 1.4: and trace global signal sig_1

  // TODO 1.4: set trace mode to Signal in dB/degrees

  // TODO 1.4: Perform an AC simulation (1.0 Hz to 1MHz, 1000 pts, log. scale)

  // TODO 1.4: and close tabular trace file

  return 0;                                  // Exit with return code 0
}
